import java.util.Random;

public class Consumer implements Runnable {

  private final EnergySource src;
  private final int id;
  private final Random r = new Random();

  public Consumer(int id, EnergySource src) {
    this.id = id;
    this.src = src;
  }

  public void run() {
    for (int i = 0; i < 10; i++) {
      src.monitor.writeLock().lock();
      try {
        long amountToConsume = (long)r.nextInt(25);
        if (amountToConsume < src.getUnitsAvailable()) {
          System.out.print("Consumer " + id + "[" + (i+1) + "]");
          System.out.print(" tries to consume " + amountToConsume + ": ");
          boolean result = src.useEnergy(amountToConsume);
          if (result) {
            System.out.println(" SUCCESS!");
          } else {
            System.out.println(" FAIL!");
          }
        } else {
          System.out.print("Consumer " + id + "[" + (i+1) + "]");
          System.out.println(" needs more energy than is available: FAIL!");
        }
      } finally {
        src.monitor.writeLock().unlock();
      }
      try {
        Thread.sleep(r.nextInt(3000));
      } catch (Exception ex) {
      }
    }
  }

}
